#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin>>t;

    while(t>0)
    {
        int n;
        cin>>n;
        vector<int> a(n);
        vector<int> b(n);
        vector<int> c(n);
        int max=0;

        for(int i=0; i<n; i++)
        {
            cin >> a[i] >> b[i] >> c[i];
        }

        vector<vector<int>> graph(2*n);
        int** gr = new int*[n*2];
        for(int i=0; i<n*2; i++)
        {
            gr[i] = new int[n*2];
        }
        for(int i=0; i<n; i++)
        {
            gr[a[i]-1][b[i]-1] = c[i];
            gr[b[i]-1][a[i]-1] = c[i];
        }
        int sum=0;
        int*s1 = new int[n*2];
        for(int i=0; i<n*2; i++)
        {
            partial_sum(&gr[i][0], &gr[i][2*n], s1);
            if(s1[n*2-1]>sum)
            {
                sum=s1[n*2-1];
            }
        }


        cout << sum << "\n";
        t--;
    }

}

